function dist = bitwiseHammingDist(Xi, Xj)
% Bitwise Hamming distance between Xi and Xj.

[m, p] = size(Xj);
dist = zeros(m, 1);

% for q = 1:p
%     dist = dist + sum( bitget( bitxor( Xi(q), Xj(:, q) ), 1:8) );
% end

for q = 1:p
    xiq = Xi(q);
    xjq = Xj(:, q);
    bx = bitxor(xiq, xjq);
    %bg = bitget(bx, 1:8);
    
    %dist = dist + sum( bg);
    %dist = arrayfun(@(a) sum(bitget(a, 1:8)), bx);
    
    for i = 1:8
        dist = dist + double(bitget(bx, i));
    end
end

dist = dist / (p * 8); 

end